<?php

class HZ_Import {

	var $posts = array ();
	var $file;

	function header() {
		echo '<div class="wrap">';
		echo '<h2>Hommingberger Zeitung importieren</h2>';
	}

	function footer() {
		echo '</div>';
	}

	function unhtmlentities($string) { // From php.net for < 4.3 compat
		$trans_tbl = get_html_translation_table(HTML_ENTITIES);
		$trans_tbl = array_flip($trans_tbl);
		return strtr($string, $trans_tbl);
	}

	function greet() {
		echo '<div class="narrow">';
		echo '<p>Importiert Artikel der Hommingberger Zeitung</p>';
		wp_import_upload_form("admin.php?import=hz&amp;step=1");
		echo '</div>';
	}

  function format_hz( $Text, $Links ) {
    $LinkList = explode( ";", $Links );
    foreach( $LinkList as $Link ) {
      if( $Link!='' ) {
        $data = explode( "=", $Link );
        $su = "/($data[0])/";
        $er = "<$data[1]>$1</$data[1]>";
        $Text = preg_replace( $su, $er, $Text );
      }
    }
    return $Text;
  }

  function links_hz( $Text, $Links ) {
    $LinkList = explode( ";", $Links );
    foreach( $LinkList as $Link ) {
      if( $Link!='' ) {
        $data = explode( "=", $Link );
        $su = "/$data[0]/";
        $er = "<a href=\"$data[1]\">$data[0]</a>";
        $Text = preg_replace( $su, $er, $Text, 1 );
      }
    }
    return $Text;
  }

	function get_posts() {
		global $wpdb;

		set_magic_quotes_runtime(0);
		$datalines = file($this->file); // Read the file into an array
		$importdata = implode('', $datalines); // squish it
		$importdata = str_replace(array ("\r\n", "\r"), "\n", $importdata);

		preg_match_all('|<item>(.*?)</item>|is', $importdata, $this->posts);
		$this->posts = $this->posts[1];
		$index = 0;
		foreach ($this->posts as $post) {
			preg_match('|<title>(.*?)</title>|is', $post, $post_title);
			$post_title = str_replace(array('<![CDATA[', ']]>'), '', $wpdb->escape( trim($post_title[1]) ));

			preg_match('|<pubdate>(.*?)</pubdate>|is', $post, $post_date_gmt);

			if ($post_date_gmt) {
				$post_date_gmt = strtotime($post_date_gmt[1]);
			} else {
				// if we don't already have something from pubDate
				preg_match('|<dc:date>(.*?)</dc:date>|is', $post, $post_date_gmt);
				$post_date_gmt = preg_replace('|([-+])([0-9]+):([0-9]+)$|', '\1\2\3', $post_date_gmt[1]);
				$post_date_gmt = str_replace('T', ' ', $post_date_gmt);
				$post_date_gmt = strtotime($post_date_gmt);
			}

			$post_date_gmt = gmdate('Y-m-d H:i:s', $post_date_gmt);
			$post_date = get_date_from_gmt( $post_date_gmt );

			preg_match_all('|<category>(.*?)</category>|is', $post, $categories);
			$categories = $categories[1];

			if (!$categories) {
				preg_match_all('|<dc:subject>(.*?)</dc:subject>|is', $post, $categories);
				$categories = $categories[1];
			}

			$cat_index = 0;
			foreach ($categories as $category) {
				$categories[$cat_index] = $wpdb->escape($this->unhtmlentities($category));
				$cat_index++;
			}

			preg_match('|<guid.+?>(.*?)</guid>|is', $post, $guid);
			if ($guid)
				$guid = $wpdb->escape(trim($guid[1]));
			else
				$guid = '';

			preg_match('|<content:encoded>(.*?)</content:encoded>|is', $post, $post_content);
			$post_content = str_replace(array ('<![CDATA[', ']]>'), '', $wpdb->escape(trim($post_content[1])));

			if (!$post_content) {
				// This is for feeds that put content in description
				preg_match('|<description>(.*?)</description>|is', $post, $post_content);
				$post_content = $wpdb->escape($this->unhtmlentities(trim($post_content[1])));
			}

			// Clean up content
			$post_content = preg_replace('|<(/?[A-Z]+)|e', "'<' . strtolower('$1')", $post_content);
			$post_content = str_replace('<br>', '<br />', $post_content);
			$post_content = str_replace('<hr>', '<hr />', $post_content);

			$post_author = 1;
			$post_status = 'publish';
			$this->posts[$index] = compact('post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_title', 'post_status', 'guid', 'categories');
			$index++;
		}
	}

	function import_posts() {
		global $wpdb;
		$dbtable = 'hgfnews';			// Tabelle
		$idoffset = 3566;

		$plw_query = "SELECT * FROM $dbtable ORDER BY id";
		$plw_results = $wpdb->get_results( $plw_query );

		echo '<ol>';

		foreach( $plw_results as $plw_entry ) {
			echo "<li>".__('Importing post...');


			// Titel
			$post_title = $wpdb->escape( trim( $plw_entry->title ) );

			// Postname aus ID
			$Id = $plw_entry->id+$idoffset;
			$post_name = $Id;
			
			// Datum 
			$post_date_gmt = strtotime( $plw_entry->pubDate );
			$post_date_gmt = gmdate('Y-m-d H:i:s', $post_date_gmt);
			$post_date = get_date_from_gmt( $post_date_gmt );
			
			// Kurzfassung
			$post_excerpt = $wpdb->escape( $plw_entry->description );
			
			// Inhalt
			$Message = $plw_entry->message;
			$LinkList = $plw_entry->links;
			$FormatList = $plw_entry->format;
			$Message = $this->links_hz( $Message, $LinkList ); 
			$Message = $this->format_hz( $Message, $FormatList ); 
		
			$Image = explode( ":", $plw_entry->image );
			if( $Image[0] != '' ) {
				$Alt = $Image[1];
				$img_file = $_SERVER['DOCUMENT_ROOT'].'/images/'.$Image[0];
				if( file_exists( $img_file ) ) {
					$ImageName = $Image[0];
					$img_size = getimagesize( $img_file );
				  $size_em = $img_size[0]/10.0;
				  $img_width = "{$size_em}em";
				}
				else { 
					$ImageName = 'hz-x.gif';
					$img_width = '18.0em';
				}
				$Img = "<img src='/images/$ImageName' alt='$Alt' title='$Alt' class='leftimg' style='width: $img_width;' />";
			}
			else
				$Img = '';

			$post_content = $wpdb->escape( $Img.$Message );

			
			// weitere feste Daten
			$post_author = 1;
			$post_status = 'publish';

			$post = compact('post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_excerpt', 'post_name', 'post_title', 'post_status');
			if ($post_id = post_exists($post_title, $post_content, $post_date)) {
				_e('Post already imported');
			} else {
				$post_id = wp_insert_post($post);
				if (!$post_id) {
					_e("Couldn't get post ID");
					return;
				}
				else {
					// Metadaten
					$Subtitle = $plw_entry->subtitle;
					if( $Subtitle != '' )
						add_post_meta( $post_id, 'subtitle', $Subtitle ); 
					$Quelle = $plw_entry->quelle;
					if( $Quelle != '' )
						add_post_meta( $post_id, 'quelle', $Quelle ); 
				}
				

				_e('Done !');
			}
			echo '</li>';
		}

		echo '</ol>';

	}

	function import() {

		$this->import_posts();

		echo '<h3>';
		printf(__('All done. <a href="%s">Have fun!</a>'), get_option('home'));
		echo '</h3>';
	}

	function dispatch() {
		if (empty ($_GET['step']))
			$step = 0;
		else
			$step = (int) $_GET['step'];

		$this->header();

		switch ($step) {
			case 0 :
				$this->greet();
				break;
			case 1 :
				//check_admin_referer('import-upload');
				$this->import();
				break;
		}

		$this->footer();
	}

	function HZ_Import() {
		// Nothing.
	}
}

$hz_import = new HZ_Import();

register_importer('hz', 'Hommingberger Zeitung', 'Importiert Artikel der Hommingberger Zeitung', array ($hz_import, 'dispatch'));
?>
